#! /bin/python

import os

SIMULATOR = "/media/jbm/JBM-WORK/CompSciMSc/Dissertation/simulators/hacksim3/target/release/hacksim3"
TEMPLATE = "template.sim"
CONFIG = "config.sim"
OUTPUT = "results.csv"
MARKER = "Total cycles: "
COMP_CYCLES = 3

lines = ["program,command,cycles"]
a_instruction_cycles = 0
comp_instruction_cycles = 0

with open(TEMPLATE) as f:
	template = f.read()

for file in os.listdir(os.fsencode("./")):
	filename = os.fsdecode(file)
	if filename.endswith(".hack"):
		populated_template = template.replace("REPLACE", filename)

		#create simulator config
		with open(CONFIG, "w") as f:
			f.write(populated_template)

		#run simulator and gather results
		command = SIMULATOR + " " + os.getcwd() + "/config.sim"
		stream = os.popen(command)
		result = stream.read()

		try:
			start = result.index(MARKER)
			end = result.index("\n", start)

			cycles = int(result[start + len(MARKER):end]) - 1 #subtract 1 to account for cycle taken to notice program has terminated

			if filename == "a_instruction.hack":
				a_instruction_cycles = cycles

			#subtract time taken to load jmp target for taken jumps
			elif filename == "unconditional_jmp.hack" or filename == "conditional_jmp_taken.hack":
				cycles -= a_instruction_cycles

			with open(filename.replace(".hack", ".asm")) as f:
				command = f.readlines()[-1]

			line = filename + "," + command + "," + str(cycles)
			lines.append(line)

			#delete simulator config
			os.remove(CONFIG)
		except Exception as e:
			print("ERROR during processing of " + filename)
			print(e)

with open(OUTPUT, "w") as out:
	for line in lines:
		out.write(line)
		out.write("\n")
